
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>JVM字节码格式 / 憋错料</title>

    <meta name="description" content="JVM字节码格式 字节码格式 字节码是JVM的机器语言.JVM加载类文件时,对类中的每个方法,它都会得到一个字节码流.这些字节码流保存在JVM的方法区中.在程序运行过程中,当一个方法被调用时,它的字节码流就会被执行.根据特定JVM设计者的选择,它们可以通过解释的方式,即时编译(Just-in-time compilation)的方式或其他技术的方式被执行. 方法的字节码流就是JVM的指令(instruction)序列.每条指令包含一个单字节的操作码(opcode)和0个或多个操作数(operand).操作码指明要">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">JVM字节码格式</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<h2>字节码格式</h2>
<p>字节码是JVM的机器语言。JVM加载类文件时，对类中的每个方法，它都会得到一个字节码流。这些字节码流保存在JVM的方法区中。在程序运行过程中，当一个方法被调用时，它的字节码流就会被执行。根据特定JVM设计者的选择，它们可以通过解释的方式，即时编译（Just-in-time compilation）的方式或其他技术的方式被执行。</p>
<p>方法的字节码流就是JVM的指令（instruction）序列。每条指令包含一个单字节的操作码（opcode）和0个或多个操作数（operand）。操作码指明要执行的操作。如果JVM在执行操作前，需要更多的信息，这些信息会以0个或多个操作数的方式，紧跟在操作码的后面。</p>
<p>每种类型的操作码都有一个助记符（mnemonic）。类似典型的汇编语言风格，Java字节码流可以用它们的助记符和紧跟在后面的操作数来表示。例如，下面的字节码流可以分解成多个助记符的形式。</p>
<pre><code>// 字节码流: 03 3b 84 00 01 1a 05 68 3b a7 ff f9
// 分解后:
iconst_0      // 03
istore_0      // 3b
iinc 0, 1     // 84 00 01
iload_0       // 1a
iconst_2      // 05
imul          // 68
istore_0      // 3b
goto -7       // a7 ff f9</code></pre>
<p>字节码指令集被设计的很紧凑。除了处理跳表的2条指令以外，所有的指令都以字节边界对齐。操作码的总数很少，一个字节就能搞定。这最小化了JVM加载前，通过网络传输的类文件的大小；也使得JVM可以维持很小的实现。</p>
<p>JVM中，所有的计算都是围绕栈（stack）而展开的。因为JVM没有存储任意数值的寄存器（register），所有的操作数在计算开始之前，都必须先压入栈中。因此，字节码指令主要是用来操作栈的。例如，在上面的字节码序列中，通过iload_0先把本地变量（local variable）入栈，然后用iconst_2把数字2入栈的方式，来计算本地变量乘以2。两个整数都入栈之后，imul指令有效的从栈中弹出它们，然后做乘法，最后把运算结果压入栈中。istore_0指令把结果从栈顶弹出，保存回本地变量。JVM被设计成基于栈，而不是寄存器的机器，这使得它在如80486寄存器架构不佳的处理器上，也能被高效的实现。</p>
<h3>原始类型（primitive types）</h3>
<p>JVM支持7种原始数据类型。Java程序员可以声明和使用这些数据类型的变量，而Java字节码，处理这些数据类型。下表列出了这7种原始数据类型：</p>
<pre><code>类型          定义
byte    单字节有符号二进制补码整数
short   2字节有符号二进制补码整数
int 4字节有符号二进制补码整数
long    8字节有符号二进制补码整数
float   4字节IEEE 754单精度浮点数
double  8字节IEEE 754双精度浮点数
char    2字节无符号Unicode字符</code></pre>
<p>原始数据类型以操作数的方式出现在字节码流中。所有长度超过1字节的原始类型，都以大端（big-endian）的方式保存在字节码流中，这意味着高位字节出现在低位字节之前。例如，为了把常量值256（0×0100）压入栈中，你可以用sipush操作码，后跟一个短操作数。短操作数会以“01 00”的方式出现在字节码流中，因为JVM是大端的。如果JVM是小端（little-endian）的，短操作数将会是“00 01”。</p>
<pre><code>// Bytecode stream: 17 01 00
// Dissassembly:
sipush 256;      // 17 01 00
</code></pre>
<h3>把常量（constants）压入栈中</h3>
<p>很多操作码都可以把常量压入栈中。操作码以3中不同的方式指定入栈的常量值：由操作码隐式指明，作为操作数跟在操作码之后，或者从常量池（constant pool）中获取。</p>
<p>有些操作码本身就指明了要入栈的数据类型和常量数值。例如，iconst_1告诉JVM把整数1压入栈中。这种操作码，是为不同类型而经常入栈的数值而定义的。它们在字节码流中只占用1个字节，增进了字节码的执行效率，并减小了字节码流的大小。下表列出了int型和float型的操作码：</p>
<pre><code>操作码                            操作数描述
iconst_m1   (none)  pushes int -1 onto the stack
iconst_0    (none)  pushes int 0 onto the stack
iconst_1    (none)  pushes int 1 onto the stack
iconst_2    (none)  pushes int 2 onto the stack
iconst_3    (none)  pushes int 3 onto the stack
iconst_4    (none)  pushes int 4 onto the stack
iconst_5    (none)  pushes int 5 onto the stack
fconst_0    (none)  pushes float 0 onto the stack
fconst_1    (none)  pushes float 1 onto the stack
fconst_2    (none)  pushes float 2 onto the stack</code></pre>
<p>下面列出的操作码处理的int型和float型都是32位的值。Java栈单元（slot）是32位宽的，因此，每次一个int数和float数入栈，它都占用一个单元。下表列出的操作码处理long型和double型。long型和double型的数值占用64位。每次一个long数或double数被压入栈中，它都占用2个栈单元。下面的表格，列出了隐含处理long型和double型的操作码</p>
<pre><code>操作码                                操作数描述
lconst_0    (none)  pushes long 0 onto the stack
lconst_1    (none)  pushes long 1 onto the stack
dconst_0    (none)  pushes double 0 onto the stack
dconst_1    (none)  pushes double 1 onto the stack</code></pre>
<p>另外还有一个隐含入栈常量值的操作码，aconst_null，它把空对象（null object）的引用（reference）压入栈中。对象引用的格式取决于JVM实现。对象引用指向垃圾收集堆（garbage-collected heap）中的对象。空对象引用，意味着一个变量当前没有指向任何合法对象。aconst_null操作码用在给引用变量赋null值的时候。</p>
<pre><code>操作码                                            操作数描述
aconst_null (none)  pushes a null object reference onto the stack</code></pre>
<p>有2个操作码需要紧跟一个操作数来指明入栈的常量值。下表列出的操作码，用来把合法的byte型和short型的常量值压入栈中。byte型或short型的值在入栈之前，先被扩展成int型的值，因为栈单元是32位宽的。对byte型和short型的操作，实际上是基于它们扩展后的int型值的。</p>
<pre><code>操作码                                                  操作数描述
bipush  byte1   expands byte1 (a byte type) to an int and pushes it onto the stack
sipush  byte1, byte2    expands byte1, byte2 (a short type) to an int and pushes it onto the stack</code></pre>
<p>有3个操作码把常量池中的常量值压入栈中。所有和类关联的常量，如final变量，都被保存在类的常量池中。把常量池中的常量压入栈中的操作码，都有一个操作数，它表示需要入栈的常量在常量池中的索引。JVM会根据索引查找常量，确定它的类型，并把它压入栈中。</p>
<p>在字节码流中，常量池索引（constant pool index）是一个紧跟在操作码后的无符号值。操作码lcd1和lcd2把32位的项压入栈中，如int或float。两者的区别在于lcd1只适用于1-255的常量池索引位，因为它的索引只有1个字节。（常量池0号位未被使用。）lcd2的索引有2个字节，所以它可以适用于常量池的任意位置。lcd2w也有一个2字节的索引，它被用来指示任意含有64位的long或double型数据的常量池位置。下表列出了把常量池中的常量压入栈中的操作码：</p>
<pre><code>操作码                        操作数描述
ldc1    indexbyte1  pushes 32-bit constant_pool entry specified by indexbyte1 onto the stack
ldc2    indexbyte1, indexbyte2  pushes 32-bit constant_pool entry specified by indexbyte1, indexbyte2 onto the stack
ldc2w   indexbyte1, indexbyte2  pushes 64-bit constant_pool entry specified by indexbyte1,indexbyte2 onto the stack</code></pre>
<h3>把局部变量（local variables）压入栈中</h3>
<p>局部变量保存在栈帧的一个特殊区域中。栈帧是当前执行方法正在使用的栈区。每个栈帧包含3个部分：本地变量区，执行环境和操作数栈区。把本地变量入栈实际上包含了把数值从栈帧的本地变量区移动到操作数栈区。操作数栈区总是在栈的顶部，所以，把一个值压到当前栈帧的操作数栈区顶部，跟压到整个JVM栈的顶部是一个意思。</p>
<p>Java栈是一个先进后出（LIFO）的32位宽的栈。所有的本地变量至少占用32位，因为栈中的每个单元都是32位宽的。像long和double类型的64位的本地变量会占用2个栈单元。byte和short型的本地变量会当做int型来存储，但只拥有较小类型的合法值。例如，表示byte型的int型本地变量取值范围总是-128到127。</p>
<p>每个本地变量都有一个唯一索引。方法栈帧的本地变量区，可以当成是一个拥有32位宽的元素的数组，每个元素都可以用数组索引来寻址。long和double型的占用2个单元的本地变量，且用低位元素的索引寻址。例如，对一个占用2单元和3单元的double数值，会用索引2来引用。</p>
<p>有一些操作码可以把int和float型本地变量压入操作数栈。部分操作码，定义成隐含常用本地变量地址的引用。例如，iload_0加载处在位置0的int型本地变量。其他本地变量，通过操作码后跟一个字节的本地变量索引的方式压入栈中。iload指令就是这种操作码类型的一个例子。iload后的一个字节被解释成指向本地变量的8位无符号索引。</p>
<p>类似iload所用的8位无符号本地变量索引，限制了一个方法最多只能有256个本地变量。有一个单独的wide指令可以把8位索引扩展为16位索引，则使得本地变量数的上限提高到64k个。操作码wide只有1个操作数。wide和它的操作数，出现在像iload之类的有一个8位无符号本地变量索引的指令之前。JVM会把wide的操作数和iload的操作数合并为一个16位的无符号本地变量索引。</p>
<p>下表列出了把int和float型本地变量压入栈中的操作码：</p>
<pre><code>操作码                                         操作数描述
iload   vindex  pushes int from local variable position vindex
iload_0 (none)  pushes int from local variable position zero
iload_1 (none)  pushes int from local variable position one
iload_2 (none)  pushes int from local variable position two
iload_3 (none)  pushes int from local variable position three
fload   vindex  pushes float from local variable position vindex
fload_0 (none)  pushes float from local variable position zero
fload_1 (none)  pushes float from local variable position one
fload_2 (none)  pushes float from local variable position two
fload_3 (none)  pushes float from local variable position three</code></pre>
<p>接下来的这张表，列出了把long和double型本地变量压入栈中的指令。这些指令把64位的数从栈帧的本地变量去移动到操作数区。</p>
<pre><code>操作码                          操作数描述
lload   vindex  pushes long from local variable positions vindex and (vindex + 1)
lload_0 (none)  pushes long from local variable positions zero and one
lload_1 (none)  pushes long from local variable positions one and two
lload_2 (none)  pushes long from local variable positions two and three
lload_3 (none)  pushes long from local variable positions three and four
dload   vindex  pushes double from local variable positions vindex and (vindex + 1)
dload_0 (none)  pushes double from local variable positions zero and one
dload_1 (none)  pushes double from local variable positions one and two
dload_2 (none)  pushes double from local variable positions two and three
dload_3 (none)  pushes double from local variable positions three and four</code></pre>
<p>最后一组操作码，把32位的对象引用从栈帧的本地变量区移动到操作数区。如下表：</p>
<pre><code>操作码                           操作数描述
aload   vindex  pushes object reference from local variable position vindex
aload_0 (none)  pushes object reference from local variable position zero
aload_1 (none)  pushes object reference from local variable position one
aload_2 (none)  pushes object reference from local variable position two
aload_3 (none)  pushes object reference from local variable position three</code></pre>
<h3>弹出到本地变量</h3>
<p>每一个将局部变量压入栈中的操作码，都有一个对应的负责弹出栈顶元素到本地变量中的操作码。这些操作码的名字可以通过替换入栈操作码名中的“load”为“store”得到。下表列出了将int和float型数值弹出操作数栈到本地变量中的操作码。这些操作码将一个32位的值从栈顶移动到本地变量中。</p>
<pre><code>操作码                                            操作数描述
istore  vindex  pops int to local variable position vindex
istore_0    (none)  pops int to local variable position zero
istore_1    (none)  pops int to local variable position one
istore_2    (none)  pops int to local variable position two
istore_3    (none)  pops int to local variable position three
fstore  vindex  pops float to local variable position vindex
fstore_0    (none)  pops float to local variable position zero
fstore_1    (none)  pops float to local variable position one
fstore_2    (none)  pops float to local variable position two
fstore_3    (none)  pops float to local variable position three</code></pre>
<p>下一张表中，展示了负责将long和double类型数值出栈并存到局部变量的字节码指令，这些指令将64位的值从操作数栈顶移动到本地变量中。</p>
<pre><code>操作码                               操作数描述
lstore  vindex  pops long to local variable positions vindex and (vindex + 1)
lstore_0    (none)  pops long to local variable positions zero and one
lstore_1    (none)  pops long to local variable positions one and two
lstore_2    (none)  pops long to local variable positions two and three
lstore_3    (none)  pops long to local variable positions three and four
dstore  vindex  pops double to local variable positions vindex and (vindex + 1)
dstore_0    (none)  pops double to local variable positions zero and one
dstore_1    (none)  pops double to local variable positions one and two
dstore_2    (none)  pops double to local variable positions two and three
dstore_3    (none)  pops double to local variable positions three and four</code></pre>
<p>最后一组操作码，负责将32位的对象引用从操作数栈顶移动到本地变量中。</p>
<pre><code>操作码                                     操作数描述
astore  vindex  pops object reference to local variable position vindex
astore_0    (none)  pops object reference to local variable position zero
astore_1    (none)  pops object reference to local variable position one
astore_2    (none)  pops object reference to local variable position two
astore_3    (none)  pops object reference to local variable position three</code></pre>
<h3>类型转换</h3>
<p>JVM中有一些操作码用来将一种基本类型的数值转换成另外一种。字节码流中的转换操作码后面不跟操作数，被转换的值取自栈顶。JVM弹出栈顶的值，转换后再将结果压入栈中。下表列出了在int，long，float和double间转换的操作码。这四种类型组合的每一个可能的转换，都有一个对应的操作码。</p>
<pre><code>操作码          操作数描述
i2l (none)  converts int to long
i2f (none)  converts int to float
i2d (none)  converts int to double
l2i (none)  converts long to int
l2f (none)  converts long to float
l2d (none)  converts long to double
f2i (none)  converts float to int
f2l (none)  converts float to long
f2d (none)  converts float to double
d2i (none)  converts double to int
d2l (none)  converts double to long
d2f (none)  converts double to float</code></pre>
<p>下表列出了将int型转换为更小类型的操作码。不存在直接将long，float，double型转换为比int型小的类型的操作码。因此，像float到byte这样的转换，需要两步。第一步，f2i将float转换为int，第二步，int2byte操作码将int转换为byte。</p>
<pre><code>操作码                       操作数描述
int2byte    (none)  converts int to byte
int2char    (none)  converts int to char
int2short   (none)  converts int to short</code></pre>
<p>虽然存在将int转换为更小类型（byte，short，char）的操作码，但是不存在反向转换的操作码。这是因为byte，short和char型的数值在入栈之前会转换成int型。byte，short和char型数值的算术运算，首先要将这些类型的值转为int，然后执行算术运算，最后得到int型结果。也就是说，如果两个byte型的数相加，会得到一个int型的结果，如果你想要byte型的结果，你必须显式地将int类型的结果转换为byte类型的值。例如，下面的代码编译出错：</p>
<pre><code>class BadArithmetic {
    byte addOneAndOne() {
        byte a = 1;
        byte b = 1;
        byte c = a + b;
        return c;
    }
}

javac会对上面的代码给出如下错误：

BadArithmetic.java(7): Incompatible type for declaration.
Explicit cast needed to convert int to byte.
                byte c = a + b;
                     ^
Java程序员必须显式的把a + b的结果转换为byte，这样才能通过编译。

class GoodArithmetic {
    byte addOneAndOne() {
        byte a = 1;
        byte b = 1;
        byte c = (byte) (a + b);
        return c;
    }
}</code></pre>
<p>这样，javac会很高兴的生成GoodArithmetic.class文件，它包含如下的addOneAndOne()方法的字节码序列：</p>
<pre><code>iconst_1  // Push int constant 1.
istore_1  // Pop into local variable 1, which is a: byte a = 1;
iconst_1  // Push int constant 1 again.
istore_2  // Pop into local variable 2, which is b: byte b = 1;
iload_1   // Push a (a is already stored as an int in local variable 1).
iload_2   // Push b (b is already stored as an int in local variable 2).
iadd      // Perform addition. Top of stack is now (a + b), an int.
int2byte  // Convert int result to byte (result still occupies 32 bits).
istore_3  // Pop into local variable 3, which is byte c: byte c = (byte) (a + b);
iload_3   // Push the value of c so it can be returned.
ireturn   // Proudly return the result of the addition: return c;</code></pre>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-28 05:56:15 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>JVM字节码格式的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0e9KKJ0.html" rel="bookmark">JVM总结（五）：JVM字节码执行引擎</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				JVM字节码执行引擎 运行时栈帧结构 局部变量表 操作数栈 动态连接 方法返回地址 附加信息 方法调用 解析 分派 –“重载”和“重写”的实现 静态分派 动态分派 单分派和多分派 JVM动态分派的实现 基于栈的字节码解释执行引擎 基于栈的指令集与基于寄存器的指令集 JVM字节码执行引擎 虚拟机是相对于“物理机”而言的,这两种机器都有代码执行能力,其区别主要是物理机的执行引擎是直接建立在处理器.硬件.指令集和操作系统层面上的,而虚拟机的执行引擎是自己实现的.因此程序员可以自行制定指令集和执行引擎的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0dy2lr3.html" rel="bookmark">JVM字节码增强</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				JVM——字节码增强技术简介 Java字节码增强指的是在Java字节码生成之后,对其进行修改,增强其功能,这种方式相当于对应用程序的二进制文件进行修改.Java字节码增强主要是为了减少冗余代码,提高性能等. 实现字节码增强的主要步骤为: 1.修改字节码 在内存中获取到原来的字节码,然后通过一些工具(如 ASM,Javaasist)来修改它的byte[]数组,得到一个新的byte数组. 2.使修改后的字节码生效 有两种方法: 1) 自定义ClassLoader来加载修改后的字节码: 2)替换掉原来			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/B0RyP9M.html" rel="bookmark">JVM&mdash;&mdash;字节码增强技术简介</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Java字节码增强指的是在Java字节码生成之后,对其进行修改,增强其功能,这种方式相当于对应用程序的二进制文件进行修改.Java字节码增强主要是为了减少冗余代码,提高性能等. 实现字节码增强的主要步骤为: 1.修改字节码 在内存中获取到原来的字节码,然后通过一些工具(如 ASM,Javaasist)来修改它的byte[]数组,得到一个新的byte数组. 2.使修改后的字节码生效 有两种方法: 1) 自定义ClassLoader来加载修改后的字节码: 2)替换掉原来的字节码:在JVM加载用户的C			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MDX7GkM.html" rel="bookmark">JVM字节码之整型入栈指令&lpar;iconst、bipush、sipush、ldc&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				官网:http://docs.oracle.com/javase/specs/jvms/se7/html/jvms-4.html 原文地址:http://www.linmuxi.com/2016/02/25/jvm-int-pushstack-01/ 本篇主要分享下在JVM中int类型数值采用何种指令入栈的,根据int值范围JVM入栈字节码指令就分为4类,下面分别介绍下这四类指令. 前言 当int取值-1~5采用iconst指令,取值-128~127采用bipush指令,取值-32768~327			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/38YWdA4.html" rel="bookmark">JVM --字节码的加载</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				ClassLoader类加载器 常见的类加载器有BootStrapClassLoader&lt;-ExtClassLoader&lt;-AppClassLoader&lt;-用户ClassLoader BootStrapClassLoader:加载Java自带的核心类: ExtClassLoader加载在/jre/lib/ext目录下的jar包,同样用户可以将jar放在该目录下. AppClassLoader 加载classpath下面的内容, 加载过程: 读取文件并加载,首先申请父类的加载器进行加载,如			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Mz6D1JM.html" rel="bookmark">JVM &vert; 字节码指令基础</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				操作数栈管理指令 1)pop.pop2:将操作数栈的栈顶一个或两个元素出栈.2)dup.dup2.dup_x1.dup2_x1.dup_x2.dup2_x2:复制栈顶一个或两个数值并将复制值或双份的复制值重新压入栈顶.3)swap:将栈最顶端两个数值互换. public static void main(String[] args) { heavyMethod(); } 对应的字节码: public static void main(java.lang.String[]); Signature:			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3vbpp63.html" rel="bookmark">jvm字节码简介</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.概述 java虚拟机的指令由一个字节长度的.代表着某种特定操作含义的数字(成为操作码,Opcde)和跟随其后的0到多个此操作所需参数(操作数,Operands).由于操作码的长度为一个字节,所以指令集的操作数总数不能超过256条:又由于Class文件放弃了编译后代码的操作数对齐,所以虚拟机在处理超过一个字节的数据时会从字节中重建出具体的数据格式,例如一个16的长度的无符号整数会使用两个无符号字节存储(byte1.byte2),它们的值为  byte1 &lt;&lt; 8 | byte2.对于大部分与			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/49Qk8W4.html" rel="bookmark">JVM 字节码的结构</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				编译的.class文件,可以用javap进行反编译 javap Test.class javap -c Test.class javap -verbose Test.class 1.创建MyTest1.java public class MyTest1 { private int a = 1; public MyTest1() { } public int getA() { return this.a; } public void setA(int a) { this.a = a; } } 使用			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/02qmApM.html" rel="bookmark">java面试题jvm字节码的加载与卸载</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				虚拟机把描述类的数据从class文件加载到内存,并对数据进行校验,转换分析和初始化,最终形成可以被虚拟节直接使用的JAVA类型,这就是虚拟机的类加载机制. 类从被加载到虚拟机内存到卸载出内存的生命周期包括:加载-&gt;连接(验证-&gt;准备-&gt;解析)-&gt;初始化-&gt;使用-&gt;卸载 初始化的5种情况: 1.使用new关键字实例化对象时,读取或设置一个类的静态字段,除被final修饰经编译结果放在常量池的静态字段,调用类的静态方法时. 2.使用java.lang.reflect包方法对			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pvLkw0.html" rel="bookmark" class="title">2015阅读计划</a>
					<div>
						此学期计划准备阅读的书籍有&lt;需求工程-软件建模与分析&gt;.&lt;软件需求十步走&gt;.&lt;需求分析与系统设计&gt;三本书 10月份阅读&lt;需求工程-软件建模与分析&gt;: 1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MgLyqK0.html" rel="bookmark" class="title">openstack 升级设计要求的指导原则</a>
					<div>
						不知道其他软件有没有类似的指导原则. Theory of Upgrade Grenade works under the following theory of upgrade. New code s ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZVj1D3.html" rel="bookmark" class="title">&amp;&num;39&semi;&amp;lt&semi;&amp;lt&semi;&amp;&num;39&semi;  &amp;&num;39&semi;&vert;&amp;&num;39&semi;  &amp;&num;39&semi;&amp;gt&semi;&amp;gt&semi;&amp;&num;39&semi;  等位运算符    课本祥解</a>
					<div>
						a&lt;&lt;1   相当于a*2     a&gt;&gt;1    相当于a/2   a&lt;&lt;|1   相当于a*2+1 一些算法用得到. '&lt;&lt;' '|' '&gt;& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLDmmBM.html" rel="bookmark" class="title">STM32&mdash;&mdash;DMA接收和发送的实现</a>
					<div>
						最近写程序,需要一段一段数据的接收,再通过其他串口发送出去. 老司机们建议用DMA通信,以节约CPU资源.然后,我听了,发现挺好用的.特此,把自己写的代码贴上了. DMA发送接收的步骤如下: 1.初始 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4AdrDb3.html" rel="bookmark" class="title">UI基础-UIView</a>
					<div>
						UIView的常见属性 NSArray *subviews 所有的子控件 数组元素的顺序决定着子控件的显示层级顺序(下标越大的,越显示在上面) UIView的常见方法 addSubview: 添加一个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/352wrn4.html" rel="bookmark" class="title">PHP通过PHP QR Code生成二维码</a>
					<div>
						1.二维码 二维码 ,又称二维条形码,它是用某种特定的几何图形按一定规律在平面(二维方向上)分布的黑白相间的图形记录数据符号信息的,在代码编制上巧妙地利用构成计算机内部逻辑基础的&quot;0&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M6bzdvM.html" rel="bookmark" class="title">Linux常用指令---tail &vert; head&lpar;查看文件&rpar;</a>
					<div>
						tail 命令从指定点开始将文件写到标准输出.使用tail命令的-f选项可以方便的查阅正在改变的日志文件,tail -f filename会把filename里最尾部的内容显示在屏幕上,并且不但刷新, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mz1XPq4.html" rel="bookmark" class="title">布局实例：用表格布局实现计算器布局</a>
					<div>
						预览效果: &lt;?xml version=&quot;1.0&quot; encoding=&quot;utf-8&quot;?&gt; &lt;TableLayout xmlns:android ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGaZEo3.html" rel="bookmark" class="title">GA代码中的细节</a>
					<div>
						GA-BLX交叉-Gaussion变异 中的代码细节: 我写了一个GA的代码,在2005测试函数上一直不能得到与实验室其他同学类似的数量级的结果.现在参考其他同学的代码,发现至少有如下问题: 1.在交 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZNAaJ3.html" rel="bookmark" class="title">md5 对字符串进行加密的方法  简单好用</a>
					<div>
						1 public static String makeMD5(String password) { 2 String result = null; 3 4 MessageDigest messageD ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02ygmaM.html" rel="bookmark" class="title">保留yum安装软件后的RPM包小知识点</a>
					<div>
						yum安装软件很方便,但是下载下来的rpm包在安装后默认会被删除掉:如果希望保留yum安装的软件包该如何做呢? 其实呢,调整方法很简单,只需将/etc/yum.conf里对应的keepcache参数改 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JvQZl4.html" rel="bookmark" class="title">堆排序实现</a>
					<div>
						1.堆排序算法描写叙述: (1)定义 n个keyword序列Kl,K2,-,Kn称为(Heap).当且仅当该序列满足例如以下性质(简称为堆性质): 1)ki&lt;=k(2i)且ki&lt;=k(2i ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47e75o0.html" rel="bookmark" class="title">NOI 2014 魔法森林&lpar;BZOJ 3669&rpar; 题解</a>
					<div>
						对边按a权值排序,按b权值建LCT,按排序后的顺序依次加边.如果加边后形成环则删除环上最大的边.如果起点终点联通则更新答案. 1 #include&lt;cstdio&gt; 2 #include&l ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0e9kJ50.html" rel="bookmark" class="title">XML学习笔记之：XSLT &amp;lt&semi;xsl&colon;value-of&amp;gt&semi; 元素</a>
					<div>
						声明:该笔记引自W3School! &lt;xsl:value-of&gt; 元素用于提取某个选定节点的值,并把值添加到转换的输出流中: &lt;?xml version=&quot;1.0&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qDkoa0.html" rel="bookmark" class="title">设计模式之读写装饰</a>
					<div>
						今天有人问我如下代码: 1 public class UserInformation 2 { 3 public string Name { get; set; } 4 5 public uint Ag ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pD8zP4.html" rel="bookmark" class="title">javascript之正则表达式学习笔记</a>
					<div>
						正则表达式的声明 直接写在/与/之间 var reg = /...../; 使用RegExp()构造函数 var reg = new RegExp(......); 在ECMAscript 3中Reg ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4QPyGB3.html" rel="bookmark" class="title">关于地图取多少公里范围内的司机&sol;商户的查询优化</a>
					<div>
						基于百度/高德地图的一些应用经常会有这样一种场景的查询: 取X公里范围内最近的Y位司机/商户. 某公司是这样做的:司机有一张司机信息表DriverInfo,另有一张司机位置信息表DriverPosit ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rpXbbM.html" rel="bookmark" class="title">HTML 之 Embed兼容问题</a>
					<div>
						首先IE只支持对Object的解析,火狐.谷歌.Safari只支持对Embed的解析. 1.传统的方法 &lt;object classid=&quot;clsid:d27cdb6e-ae6d-11c ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xmzj73.html" rel="bookmark" class="title">J2EE开发框架搭建（6） - 使用hibernate4完成基本Dao的封装</a>
					<div>
						现在orm框架有很多,比如说guzz,hibernate,mybaits....,在封装一个框架的时候我们可以选择一种,也可以选择多种实现,供以后使用选择,这里我只实现了hibernate,目录结构图 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGxZnQ0.html" rel="bookmark" class="title">Spring JTA multiple resource transactions in Tomcat with Atomikos example--转载</a>
					<div>
						原文地址:http://www.javacodegeeks.com/2013/07/spring-jta-multiple-resource-transactions-in-tomcat-with-a ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 11 q. 0.026 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
